<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="用户id" prop="userId">
        <el-input v-model="queryParams.userId" placeholder="请输入用户id" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="真实姓名" prop="name">
        <el-input v-model="queryParams.name" placeholder="请输入真实姓名" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="身份证" prop="idNo">
        <el-input v-model="queryParams.idNo" placeholder="请输入身份证" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="联系电话" prop="phone">
        <el-input v-model="queryParams.phone" placeholder="请输入联系电话" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="就诊卡号" prop="cardNo">
        <el-input v-model="queryParams.cardNo" placeholder="请输入就诊卡号" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="是否默认 " prop="isYes">
        <el-select v-model="queryParams.isYes" placeholder="请选择是否默认 " clearable size="small">
          <el-option v-for="dict in this.getDictDatas(DICT_TYPE.USER_CARD_IS_YES)"
                       :key="dict.value" :label="dict.label" :value="dict.value"/>
        </el-select>
      </el-form-item>
      <el-form-item label="病人id" prop="patientId">
        <el-input v-model="queryParams.patientId" placeholder="请输入病人id" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="创建时间" prop="ctime">
        <el-date-picker v-model="queryParams.ctime" style="width: 240px" value-format="yyyy-MM-dd HH:mm:ss" type="daterange"
                        range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" :default-time="['00:00:00', '23:59:59']" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['system:card:create']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                   v-hasPermi="['system:card:export']">导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="表id" align="center" prop="id" />
      <el-table-column label="用户id" align="center" prop="userId" />
      <el-table-column label="真实姓名" align="center" prop="name" />
      <el-table-column label="身份证" align="center" prop="idNo" />
      <el-table-column label="联系电话" align="center" prop="phone" />
      <el-table-column label="就诊卡号" align="center" prop="cardNo" />
      <el-table-column label="费用类别" align="center" prop="identity" />
      <el-table-column label="是否默认 " align="center" prop="isYes">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.USER_CARD_IS_YES" :value="scope.row.isYes" />
        </template>
      </el-table-column>
      <el-table-column label="病人id" align="center" prop="patientId" />
      <el-table-column label="创建时间" align="center" prop="ctime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.ctime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['system:card:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['system:card:delete']">删除</el-button>
          <el-button size="mini" type="text" icon="el-icon-shield" @click="handleBlacklist(scope.row)"
                     v-hasPermi="['system:nxbalcklist:create']">拉黑</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="用户id" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入用户id" />
        </el-form-item>
        <el-form-item label="真实姓名" prop="name">
          <el-input v-model="form.name" placeholder="请输入真实姓名" />
        </el-form-item>
        <el-form-item label="身份证" prop="idNo">
          <el-input v-model="form.idNo" placeholder="请输入身份证" />
        </el-form-item>
        <el-form-item label="联系电话" prop="phone">
          <el-input v-model="form.phone" placeholder="请输入联系电话" />
        </el-form-item>
        <el-form-item label="就诊卡号" prop="cardNo">
          <el-input v-model="form.cardNo" placeholder="请输入就诊卡号" />
        </el-form-item>
        <el-form-item label="是否默认 " prop="isYes">
          <el-select v-model="form.isYes" placeholder="请选择是否默认 ">
            <el-option v-for="dict in this.getDictDatas(DICT_TYPE.USER_CARD_IS_YES)"
                       :key="dict.value" :label="dict.label" :value="dict.value" />
          </el-select>
        </el-form-item>
        <el-form-item label="病人id" prop="patientId">
          <el-input v-model="form.patientId" placeholder="请输入病人id" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 拉黑对话框 -->
    <el-dialog :title="'拉黑用户'" :visible.sync="blacklistOpen" width="500px" append-to-body>
      <el-form ref="blacklistForm" :model="blacklistForm" :rules="blacklistRules" label-width="80px">
        <el-form-item label="用户ID" prop="userId">
          <el-input v-model="blacklistForm.userId" placeholder="用户ID" disabled />
        </el-form-item>
        <el-form-item label="拉黑类型" prop="black">
          <el-select v-model="blacklistForm.black" placeholder="请选择拉黑类型">
            <el-option label="挂号黑名单" value="1" />
            <el-option label="体检预约黑名单" value="2" />
            <el-option label="全部" value="3" />
            <el-option label="登录黑名单" value="4" />
          </el-select>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitBlacklist">确 认 拉 黑</el-button>
        <el-button @click="cancelBlacklist">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createCard, updateCard, deleteCard, getCard, getCardPage, exportCardExcel } from "@/api/system/card";
import { createnxbalcklist } from "@/api/system/nxbalcklist";
import { DICT_TYPE } from "@/utils/dict";
import DictTag from "@/components/DictTag";

export default {
  name: "Card",
  components: {
    DictTag
  },
  data() {
    return {
      DICT_TYPE,
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 就诊卡列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        userId: null,
        name: null,
        idNo: null,
        phone: null,
        cardNo: null,
        isYes: null,
        patientId: null,
        ctime: [],
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      // 黑名单弹窗参数
      blacklistOpen: false,
      // 黑名单表单
      blacklistForm: {
        userId: null,
        black: null
      },
      // 黑名单表单校验
      blacklistRules: {
        black: [
          { required: true, message: '请选择拉黑类型', trigger: 'change' }
        ]
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      // 执行查询
      getCardPage(this.queryParams).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        userId: undefined,
        name: undefined,
        idNo: undefined,
        phone: undefined,
        cardNo: undefined,
        isYes: undefined,
        patientId: undefined,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加就诊卡";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getCard(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改就诊卡";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        // 修改的提交
        if (this.form.id != null) {
          updateCard(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createCard(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除就诊卡编号为"' + id + '"的数据项?').then(function() {
          return deleteCard(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.$modal.confirm('是否确认导出所有就诊卡数据项?').then(() => {
          this.exportLoading = true;
          return exportCardExcel(params);
        }).then(response => {
          this.$download.excel(response, '就诊卡.xls');
          this.exportLoading = false;
        }).catch(() => {});
    },
    /** 处理拉黑按钮操作 */
    handleBlacklist(row) {
      this.blacklistForm.userId = row.userId;
      this.blacklistForm.black = null;
      this.blacklistOpen = true;
    },
    /** 取消拉黑操作 */
    cancelBlacklist() {
      this.blacklistOpen = false;
      this.resetBlacklistForm();
    },
    /** 重置拉黑表单 */
    resetBlacklistForm() {
      this.blacklistForm = {
        userId: null,
        black: null
      };
      this.resetForm("blacklistForm");
    },
    /** 提交拉黑表单 */
    submitBlacklist() {
      this.$refs['blacklistForm'].validate(valid => {
        if (!valid) {
          return;
        }
        this.$modal.confirm('确认要将此用户添加到黑名单吗？').then(() => {
          return createnxbalcklist({
            userId: this.blacklistForm.userId,
            black: this.blacklistForm.black
          });
        }).then(() => {
          this.$modal.msgSuccess("添加到黑名单成功");
          this.blacklistOpen = false;
          this.resetBlacklistForm();
        }).catch(() => {});
      });
    }
  }
};
</script>
